From e2dcc92a790474997f5978e01c7c3729ee674d80 Mon Sep 17 00:00:00 2001
From: sezero <sezero@users.sourceforge.net>
Date: Sun, 22 Jan 2017 11:20:10 +0300
Subject: [PATCH 6/9] bitmath.h: provide a FLAC__clz_uint32 inline asm solution
 for Watcom

---
 src/libFLAC/include/private/bitmath.h | 11 +++++++++++
 1 file changed, 11 insertions(+)

diff --git a/src/libFLAC/include/private/bitmath.h b/src/libFLAC/include/private/bitmath.h
index 12a3fb9..bf180f5 100644
--- a/src/libFLAC/include/private/bitmath.h
+++ b/src/libFLAC/include/private/bitmath.h
@@ -42,6 +42,16 @@
 #include <intrin.h> /* for _BitScanReverse* */
 #endif
 
+#ifdef __WATCOMC__
+static inline unsigned FLAC__clz_uint32 (FLAC__uint32);
+#pragma aux FLAC__clz_uint32 = \
+    "bsr eax, eax" \
+    "xor eax, 31" \
+    parm [eax] nomemory \
+    value [eax] \
+    modify exact [eax] nomemory;
+
+#else
 /* Will never be emitted for MSVC, GCC, Intel compilers */
 static inline uint32_t FLAC__clz_soft_uint32(FLAC__uint32 word)
 {
@@ -90,6 +100,7 @@ static inline uint32_t FLAC__clz_uint32(FLAC__uint32 v)
 	return FLAC__clz_soft_uint32(v);
 #endif
 }
+#endif
 
 /* Used when 64-bit bsr/clz is unavailable; can use 32-bit bsr/clz when possible */
 static inline uint32_t FLAC__clz_soft_uint64(FLAC__uint64 word)
-- 
1.8.5.5

